#!/usr/bin/env bash
echo -e "\e[1m© Dobrov расширения проводника Астра Linux, утилиты, KDE-сервисы…\e[0m\n"

issu(){ [ $UID -eq 0 -o -r /proc/kcore -o -w /etc ];} # запуск от админа?
isterm(){ ps -o stat= -p $$ | grep -q \+;} # запуск из терминала? иначе из графической среды
exiter(){ [[ $1 =~ ^-e ]] && { e=$2;shift 2;} #цвет в консоли
	set -- "${1:-запустите от администратора}" "${2:-Сбой настройки профиля}"
	isterm && echo -e "\e[${e:-41m} $1 \e[0m" || notify-send -t 19999 -u critical "$2" "$1"; exit
}
which_ex(){ local C Z=0 OPTIND # [-q|-n одно имя|-o no args] cmd "cmd2 args"
	while getopts :qno C;do case $C in q)Z=2;;n)Z=1;;o)Z=3;;esac;done;shift $[$OPTIND-1]
	for C; do set -- $C; C=$(which $1 2>/dev/null); (($Z)) && C=$(basename "$C")
	((${#C}))&&{ [[ $Z -ne 2 ]] &&echo $C$([[ -n ${*:2} && $Z -lt 3 ]] &&echo " ${*:2}");break;};done
}
esc(){ sed 's/\([\"|\'\''|\$|\^|\{|\[|\(|\||\)|\+|\?|\/|\\|\.|\*]\)/\\\1/g'<<<"$@";}
pkg_add=$(which_ex -n 'pkcon -y install' 'apt-get -qq install' 'pacman --noconfirm -S' 'emerge -y' 'yum -y install' 'zypper --non-interactive in'); is_inst=$(which_ex -n 'pkcon get-details' 'dpkg-query --show' 'pacman -Q' 'emerge -pv' 'yum info' 'zypper se -i')
add_pkg(){ for pkg in "$@"; do # ошибка или pkgname:deb ? сначала ставим из ./pkg/имя
		[[ ${pkg##*:} = deb || -z $(which_ex ${pkg%%:*}) ]] && \
			apt-get -qq install ./pkg/${pkg%%:*}*.deb 2>/dev/null && continue #локальный пакет установлен
		p=($(${is_inst:-dpkg-query --show} ${pkg%%:*} 2>/dev/null))
		[[ -z $p || $p = ${pkg%%:*} ]] && ${pkg_add:-apt-get -qq install} ${pkg%%:*}
	done #для apt вместо -y рекомендуется --assume-no
}
stat_users(){ # [-r] /home[/DOMAIN] хомяк, ID юзера, ID группы
	local users recurse; [[ $1 = -r ]] && { recurse=1; shift;}; cd ${1:-/home}
	users=$(LC_ALL=C stat -t -c '%n %u %g %F' ./* | grep -vnwE "[[:upper:]]+|*found" 2>/dev/null | \
		sed "/directory/!d;s/^[0-9]*:\./$(esc ${1:-/home})/;s/ directory//") #home, ID юзера, группы
	(($recurse)) || while read u; do
		[[ -n $u ]] && users="$users\n$(stat_users -r $u)"
	done <<< $(stat -c %n -t /home/* | grep -wE "[[:upper:]]+") #только домены
	printf "$users"
}
cp_user(){ # [-c только права] source home uid gid; копировать source в хомяк юзера, сменив владельца, группу, права
	local c=; [[ $1 =~ ^-c ]] && { c=1;shift; set -- $2 $1 $3 $4;}; [[ -d $1 && -n $3 ]] || return
	chown -R $3:${4:-$(grep video /etc/group|cut -d: -f3)} $1 2>/dev/null; # ./user сохранять существующие
	chmod -R u+rwX,go+rX,go-w $1; [[ -n $c ]] && return # ./skel перезаписать все файлы юзера
	cp -ra $1/skel/. $2 2>/dev/null || { echo -e "\e[41m Доступ запрещён, пропускаем пользователя: ${2##*/} \e[0m"; return;}
	cp -ran $1/user/. $2; b=$2/.local/share/krusader/krbookmarks.xml #755 dir, 644 file, обновить
	[[ -s $b ]] && sed -i "s/file:.*\/Избранное/"$(esc file:///home/${2##*/}/Избранное)"/g" $b 2>/dev/null
}
issu && su=su || su=; tmp=/tmp/runfly$su; mkdir -p $tmp; rm -R $tmp/* 2>/dev/null
b=$(dirname $0)/system/usr/local/bin; chmod ugo+x $b/runfly $b/unoreplace  #общий в /usr/local/bin, хомяк в ~/.local

issu || { # НЕ АДМИН: установка только для текущего пользователя
	[[ -z $DISPLAY ]] && exiter "Установка невозможна! Графический сеанс не найден!"
	cp -r $(dirname $0)/system/etc/xdg/. $HOME/.config
	cp -r $(dirname $0)/system/etc/skel/. $HOME 2>/dev/null
	cp -ru $(dirname $0)/user/. $HOME
	cp $r $HOME/.local 2>/dev/null # из system перезаписать всё; user только обновить файлы
	ADD=$HOME/.local; [[ ! $PATH =~ $ADD ]] && export PATH=$ADD:$PATH
	cp $b/runfly $b/unoreplace $HOME/.local
	sed -i "s/file:.*\/Избранное/"$(esc file:///home/$USER/Избранное)"/g" ~/.local/share/krusader/krbookmarks.xml
	exiter -e 44m "EMail tools, меню «Создать», «Действия», Net-сканер \n Для полной установки нужен запуск от администратора \n Ваши и чужие шаблоны документов не перезаписываются" "Расширение RunFly добавлено для $USER"
}
add_pkg conky-std libreoffice imagemagick qpdf poppler-utils konsole krusader:deb libkf5kiogui5 keditbookmarks:deb
which krusader &>/dev/null || exiter "Ошибка! Krusader не установлен! Возможно система не обновлена, имеет сбои или недоступна сеть.\n Установите krusader из Synaptic или консоли, затем перезапустите скрипт…"
v=$(krusader -v 2>/dev/null|cut -d' ' -f2); ((${v:2:1}<7)) && echo -e "\e[45m Обновите файл-менеджер Krusader из каталога /pkg ! \n Рекомендуется 2.7 и выше. Установлена версия $v \e[0m"
u=$(head -1 /etc/astra_update_version 2>/dev/null);u=${u#* }; lsb_release -c|grep -q smolensk && ((${u:-0}<10)) && echo -e "\e[45m\e[5m Рекомендуется установить обновления безопасности версии 10 и выше! \e[0m"
# добавить имя хоста в случае ошибки: sudo: unable to resolve host … В соединении отказано
dn=$(dnsdomainname); grep -q $(hostname) /etc/hosts || { echo 127.0.1.1 ${dn:+$(hostname).$dn }$(hostname) | tee -a /etc/hosts && echo "добавлено в /etc/hosts имя компьютера ${dn:+и домен $dn}";}

cp -Lr ./system/. /; n=0 #обновить системные файлы, skel-профиль, исправить ошибки пакета krusader
for i in insert-text:dialog-messages view-refresh:exchange-positions changes-allow:pin changes-prevent:lock; do
	for s in 16 22 24 32 48; do o=(actions actions status status); p=/usr/share/icons
		ln -s $p/Adwaita/${s}x$s/${o[$n]}/${i%%:*}.png $p/hicolor/${s}x$s/actions/${i##*:}.png 2>/dev/null
done; let n++; done; update-icon-caches $p #add icons for Krusader

cp -Lr ./system/etc/skel ./user $tmp # из system перезаписать всё; user только обновить файлы
while read i; do u=($i) # конфиги входившим в X-сеанс; не перезаписывать важные файлы
	[[ -f $u/.Xauthority ]] && cp_user $tmp $i # update new юзеры при первом входе из /etc/skel
done <<<$(stat_users) # $i = хомяк UID group

exiter -e 44m " Установлены проводник Krusader, монитор системы Conky \n (отключаются в автозапуске). Mail Tools и Сканер сети.\n Дополнения для меню проводника «Создать» и «Действия» \n Всем пользователям копируются рекомендуемые настройки \n НЕ перезаписываются шаблоны документов пользователей. "

# вернуть стандартное меню «Создать» (где всего 4 шаблона): sudo apt-get install fly-fm-libs --reinstall